import { split_promise } from "./utils.ts";

export class Channel<T> {
	queue_receiving = [] as ((item: T) => void)[];
	queue_sending = [] as (() => T)[];

	async send(item: T) {
		const [first] = this.queue_receiving.splice(0, 1);
		if (first !== undefined) return first(item);
		const [promise, resolve] = split_promise();
		const fn = () => ([resolve(), item] as const)[1];
		this.queue_sending.push(fn);
		await promise;
	}

	async receive() {
		const [first] = this.queue_sending.splice(0, 1);
		if (first !== undefined) return first();
		const [promise, resolve] = split_promise<T>();
		this.queue_receiving.push(resolve);
		return await promise;
	}
}
