// deno-lint-ignore no-explicit-any
export type Arr<T = any> = T[];
// deno-lint-ignore no-explicit-any
export type Function<I extends Arr, O = any> = (...input: I) => O;
// deno-lint-ignore no-explicit-any
export type Tail<A extends Arr> = A extends [any, ...infer T] ? T : never;
// deno-lint-ignore no-explicit-any
export type KeyOfType<T, V> = keyof { [P in keyof T as T[P] extends V ? P : never]: any };

export type InstanceOf<C = unknown> = { constructor: { prototype: C } };
export type Constructible<I, Args extends Arr> = new (...args: Args) => I;
export type ClassOf<I = unknown> = Constructible<I, unknown[]>;
